<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:ns0="http://xml.netbeans.org/schema/AlertMessage"
                exclude-result-prefixes="xs xd" version="2.0">
    <xsl:output method="xml" encoding="UTF-8" indent="yes"/>
    <xsl:param name="MailMessage"/>
    
    <!-- 
        This stylesheet takes the Vyopta alert email message body as a parameter,
        and outputs XML as per the AlertMsg Schema. Note that lines are delimited
        by CRLF as per SMTP requirements. 
    -->
    
    <xsl:template name="Devices">
        <xsl:param name="devString"/>
        <xsl:if test="string-length(normalize-space($devString))">
            <ns0:Device>
                <ns0:Name>
                    <xsl:value-of select="substring-before($devString, '&#xD;&#xA;')"/>
                </ns0:Name>
                <xsl:variable name="ds1" select="substring-after($devString, '&#xD;&#xA;')"/>
                <ns0:Status>
                    <xsl:value-of select="substring-before($ds1, '&#xD;&#xA;')"/>
                </ns0:Status>
                <xsl:variable name="ds2" select="substring-after($ds1, '&#xD;&#xA;')"/>
                <ns0:Host>
                    <xsl:value-of select="substring-before($ds2, '&#xD;&#xA;')"/>
                </ns0:Host>
            </ns0:Device>
            <!-- Now trim the input and go round again -->
            <xsl:call-template name="Devices">
                <xsl:with-param name="devString"
                                select="substring-after(substring-after(substring-after($devString, '&#xD;&#xA;'),'&#xD;&#xA;'),'&#xD;&#xA;')"/>
            </xsl:call-template>
        </xsl:if>
    </xsl:template>
   
    
    <xsl:template name="Header">
        <xsl:param name="msgTxt"/>
        <ns0:Header>
            <ns0:Title>
                <xsl:value-of select="substring-before($msgTxt,'&#xD;&#xA;&#xD;&#xA;')"/>
            </ns0:Title>
            <ns0:Message>
                <xsl:value-of select="substring-after($msgTxt,'&#xD;&#xA;&#xD;&#xA;')"/>
            </ns0:Message>
        </ns0:Header>
    </xsl:template>
   
    
    <xsl:template match="/*">
        <ns0:AlertMsg xmlns:ns0="http://xml.netbeans.org/schema/AlertMessage">
            <xsl:call-template name="Header">
                <xsl:with-param name="msgTxt" select="substring-before($MailMessage, '&#xD;&#xA;&#xD;&#xA;&#xD;&#xA;&#xD;&#xA;')"/>   
            </xsl:call-template>
            <xsl:call-template name="Devices">
                <xsl:with-param name="devString" select="substring-after($MailMessage, '&#xD;&#xA;&#xD;&#xA;&#xD;&#xA;&#xD;&#xA;')"/>   
            </xsl:call-template>
        </ns0:AlertMsg>
    </xsl:template>
    
</xsl:stylesheet>